/*
Small Machine Problem #0
CS 241, Spring 2009
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void print_string_with_dollar_terminator(char *str)
{
/*
  [Part 2, Task 1]:
     With standard C-strings, the terminating character is
     the NULL character. Modify `print_string_with_dollar_terminator()`
     to print (use printf) the input string `char *str` with '$' as the
     terminating character instead of the NULL character. (When printing
     the string, include the '$' as the last character printed to the
     screen. Also, print any NULL characters as two characters: a
     backslash ('\') following by a zero ('0'). You can assume that
     a '$' will appear in the input string.

     Therefore, if the input is:        The output should be:
       "abcdefg$hijklm$"                   abcdefg$
       "abc\0def$"                         abc\0def$
       "aabbcc$$"                          aabbcc$
       "orange and blue $ 2"               orange and blue $

     NOTE: Only in [Part 2, Task 1] do we consider '$' the terminating
     character. In all other tasks, we assume standard C-strings.
*/

}

int is_binary_safe(char *str, int length)
{
/*
  [Part 2, Task 2]:
     In standard C-strings, the terminating character is
     the NULL character. This works out fine when we just have
     normal ASCII text, but binary-encoded data such as pictures,
     music, and videos often contain the NULL character as valid
     data. The function is_binary_safe() has two parameters:
       (1): `char *str`: A character-pointer of data.
       (2): `int length`: The length of the entire data.

     Modify is_binary_safe() so that the function returns 0 if
     and only if `char *str` contains a NULL character within
     the first `int length` characters. Otherwise, return any
     value except 0.

     HINT: The <string.h> function strlen() may come in handy here.
*/

	return 0;
}

int count_Illinois(char *str)
{
/*
  [Part 2, Task 3]:
     Modify count_Illinois() to return the number of times
     that the string "Illinois" appears in `char *str`.

	 NOTE: Matching should be case-specific.
*/

	return 0;
}

char *big_string(char *s1, char *s2, char *s3)
{
/*
  [Part 2, Task 4]:
     Modify big_string() to return the concatenation of
     the three input strings, `s1`, `s2`, and `s3`.

     Therefore, if the input is:        The return value should be:
        "abc", "def", "ghi"                "abcdefghi"
        "aaa", "bbb", "ccc"                "aaabbbccc"
        "a"  , "a"  ,  ""                  "aa"
 
     HINT: Remember to allocate enough memory for your return string
     and make sure your string is NULL-terminated. (If you use
     <string.h> functions, this may be taken care of for you.)

     NOTE: In this task, you will need to return a string. As you
     can see in smp0.c, we will free() the return string for you.
     All other strings you use you must free() yourself.
 */

	return NULL;
}

char *overlay_overlay(char *s1, char *s2, char *s3, char *s4)
{
/*
  [Part 2, Task 5]: 
     Modify overlay_overlay() to return the overlap of overlaps
     of a set of input strings. This function should first find
     the longest overlap of `s2` in `s1`. For example, if the
     input is as follows:
          
         s1 = "the quick brown fox jumped over the lazy dog"
         s2 = "dog treat"

     ...the largest overlap of `s2` in `s1` would be the
     string "dog" since three characters overlap. If the
     input was just slightly different:
  
         s1 = "the quick brown fox jumped over the lazy dog "
         s2 = "dog treat"

     ...the largest overlap would now be "dog ". Having done this
     for `s1` and `s2`, repeat this same process for `s3` and `s4`.
     Finally, to return the "overlap of overlaps", find the longest
     overlap between the two longest overlaps you found earlier.

     For example, if our full input is:

         "computer", "mputr", "putt", "putter"
             v          v       v        v
             ------------       ----------
                 v                  v
               "mput"             "putt"
                 v                  v
                 --------------------
                          v
                        "put"

     ...the return value of the function should be "put".

     In this task, it may be helpful to write a helper function. Feel
     free to write any additional functions so long as you include
     them inside smp0.part2.c.

     NOTE: In this task, you will need to return a string. As you
     can see in smp0.c, we will free() the return string for you.
     All other strings you use you must free() yourself.
 */

	return NULL;
}

